// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/components/physics/2d/CharacterController2D.hpp"

namespace Dawn {
  class PlayerController : public SceneItemComponent {
    protected:
      CharacterController2D *characterController;

    public:
      // @optional
      float_t moveSpeed = 80.0f;

      PlayerController(SceneItem *item);

      std::vector<SceneItemComponent*> getDependencies() override;

      void onStart() override;
  };
}